﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using System.Data.OleDb;

namespace InfragisticsHierarchicalGrid2
{
    public partial class WebUserControl2 : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // Set up connection and command to retrieve the Customers table
                OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Nwind.mdb");
                //retrieve all customers (including country data for each customer)
                OleDbCommand comCountries = new OleDbCommand("select distinct Country from Customers", con);

                // Set up a data adapter to fill up a dataset with data from the query
                OleDbDataAdapter daCountries = new OleDbDataAdapter(comCountries);
                DataSet countryDataSet = new DataSet();

                con.Open();

                // Retrieve data from the database into the customers table
                daCountries.Fill(countryDataSet, "Countries");

                con.Close();

                if (countryDataSet != null)
                {
                    DropDownList1.DataSource = countryDataSet.Tables[0];
                    DropDownList1.DataValueField = "Country";
                    DropDownList1.DataTextField = "Country";
                    DropDownList1.DataBind();

                    DropDownList1.Items.Insert(0, new ListItem("", ""));
                }
            }
        }

        private void BindGrid1()
        {
            DataTable productFamily = new DataTable("ProductFamily");
            productFamily.Columns.Add("PRODUCT_FAMILY_DESCRIPTION");
            productFamily.Columns.Add("PRODUCT_FAMILY_ID");
            productFamily.Columns.Add("PROJECT_ID");
            productFamily.Rows.Add("productdesc1", 1);
            productFamily.Rows.Add("productdesc1", 2);
            productFamily.Rows.Add("productdesc1", 3);
            productFamily.Rows.Add("productdesc1", 4);

            DataTable project = new DataTable("Project");
            project.Columns.Add("ARCHITECTURE_YEAR");
            project.Columns.Add("PROJECT_NAME");
            project.Columns.Add("PROJECT_STATUS_DESCRIPTION");
            project.Columns.Add("PROJECT_ID");
            project.Columns.Add("PRODUCT_FAMILY_ID");
            project.Rows.Add("2010", "project1", "finished", 1, 1);
            project.Rows.Add("2010", "project2", "finished", 2, 1);
            project.Rows.Add("2009", "project3", "progress", 3, 2);
            project.Rows.Add("2010", "project4", "progress", 4, 2);
            project.Rows.Add("2010", "project5", "finished", 5, 3);
            project.Rows.Add("2009", "project6", "progress", 6, 3);
            project.Rows.Add("2009", "project5", "finished", 7, 4);

            DataSet ds = new DataSet();
            ds.Tables.Add(productFamily);
            ds.Tables.Add(project);
            DataRelation rel = new DataRelation("FamToPro", ds.Tables["ProductFamily"].Columns["PRODUCT_FAMILY_ID"], ds.Tables["Project"].Columns["PRODUCT_FAMILY_ID"]);
            ds.Relations.Add(rel);

            ProjectWebHierarchicalDataGrid.DataSource = ds;
        }

        private void BindGrid2()
        {
            // Set up connection and command to retrieve the Customers table
            OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Nwind.mdb");
            //retrieve all customers (including country data for each customer)
            OleDbCommand comCustomers = null;
            if (DropDownList1.SelectedValue != "")
                comCustomers = new OleDbCommand("select CustomerID, ContactName, ContactTitle, Address, City, Region, Country, Phone from Customers where Country = '" + DropDownList1.SelectedValue + "'", con);
            else
                comCustomers = new OleDbCommand("select CustomerID, ContactName, ContactTitle, Address, City, Region, Country, Phone from Customers", con);

            // Set up a data adapter to fill up a dataset with data from the query
            OleDbDataAdapter daCustomers = new OleDbDataAdapter(comCustomers);
            DataSet countryCustomersDataSet = new DataSet();

            con.Open();

            // Retrieve data from the database into the customers table
            daCustomers.Fill(countryCustomersDataSet, "Customers");

            con.Close();

            //create a dataview of the customers table, sorted by country name
            DataView dv = countryCustomersDataSet.Tables["Customers"].DefaultView;
            dv.Sort = "Country ASC";
            //add a new table called "Countries" with the distinct Country column values from the Customers table
            countryCustomersDataSet.Tables.Add(dv.ToTable("Countries", true, "Country"));

            //Set up a data relation for the Customers table with the Countries table
            //using the country column values to match records in a parent-child relationship
            DataRelation rel = new DataRelation("CountryCustomers",
                countryCustomersDataSet.Tables["Countries"].Columns["Country"],
                countryCustomersDataSet.Tables["Customers"].Columns["Country"]);
            countryCustomersDataSet.Relations.Add(rel);

            // Set the table's primary key field
            countryCustomersDataSet.Tables["Countries"].PrimaryKey = new DataColumn[] { 
                    countryCustomersDataSet.Tables["Countries"].Columns["Country"] };

            // Set up data source and bind to grid
            this.WebHierarchicalDataGrid1.DataSource = countryCustomersDataSet;

            this.WebHierarchicalDataGrid1.DataMember = "Countries";
            this.WebHierarchicalDataGrid1.DataKeyFields = "Country";
            this.WebHierarchicalDataGrid1.DataBind();
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            //BindGrid1();
            BindGrid2();
        }

        protected void ProjectWebHierarchicalDataGrid_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            ((ContainerGridRecord)e.Row).Expanded = true;
        }

        protected void WebHierarchicalDataGrid1_InitializeRow(object sender, RowEventArgs e)
        {
            ((ContainerGridRecord)e.Row).Expanded = true;
        }
    }
}